#include <Foundation/Foundation.h>
#include "NSSound_test.h"

int main (int argc, char *argv[])
{
  NSAutoreleasePool *pool;
  NSString *file;
  NSSound *sound;

  if (argc != 2)
    {
      NSLog (@"Tool misuse!");
      return 1;
    }

  pool = [[NSAutoreleasePool alloc] init];

  NSLog (@"%@", [NSSound soundUnfilteredFileTypes]);
  NSLog (@"%@", [NSSound soundUnfilteredTypes]);

  file = [NSString stringWithCString: argv[1]];
//  file2 = [NSString stringWithCString: argv[2]];
  sound = [[NSSound alloc] initWithContentsOfFile: file byReference: NO];
//  sound2 = [[NSSound alloc] initWithContentsOfFile: file2 byReference: NO];
  if (sound == nil)
    {
      NSLog (@"Could not initialize sound");
      return 1;
    }

  NSLog (@"Duration = %g", [sound duration]);
  NSLog (@"Play: %d", [sound play]);
  sleep (3);
//  NSLog (@"Play2: %d", [sound2 play]);

  NSLog (@"Pause: %d", [sound pause]);
  NSLog (@"Current Time = %g", [sound currentTime]);
  sleep (2);

  NSLog (@"Stop: %d", [sound stop]);
  sleep (2);

  NSLog (@"Play: %d", [sound play]);
  [sound setCurrentTime: 10.0];
  sleep (1);

  NSLog (@"Pause: %d", [sound pause]);
  sleep (1);
  NSLog (@"Resume: %d", [sound resume]);
  NSLog (@"Current Time = %g", [sound currentTime]);

//  [sound2 stop];
  while ([sound isPlaying])
    {
      NSLog (@"%2d:%02d/%d:%02d", 
        (int)[sound currentTime]/60, (int)[sound currentTime]%60,
        (int)[sound duration]/60, (int)[sound duration]%60);
      sleep(3);
    }

//  RELEASE(sound2);
  RELEASE(sound);

  RELEASE(pool);
  return 0;
}
